<?php
$descriptorspec = array(
   0 => array('pipe', 'r'),  // stdin is a pipe that the child will read from
   1 => array('pipe', 'w'),  // stdout is a pipe that the child will write to
//   2 => array('file', './error-output.txt', 'a') // stderr is a file to write to
   2 => array('pipe', 'w')
);

$cwd = getcwd();
$env = array('LANG' => 'cs_CZ.UTF-8');

$stdin = @file_get_contents('php://input');

$params = json_decode($stdin, true);
$input_type = $params['input_type'];

$process = proc_open('./web.py ' . $input_type, $descriptorspec, $pipes, $cwd, $env);

if (is_resource($process)) {
    date_default_timezone_set('UTC');
    $path = './cache/' . date('m-d-H-i-s');
    $path_in = $path . '-in.txt';

    file_put_contents($path_in, $params['input_type'] . "\n" . $params['input']);
    fwrite($pipes[0], $params['input']);
    fclose($pipes[0]);

    $stdout = stream_get_contents($pipes[1]);
    fclose($pipes[1]);

    $stderr = stream_get_contents($pipes[2]);
    fclose($pipes[2]);

    // It is important that you close any pipes before calling
    // proc_close in order to avoid a deadlock
    proc_close($process);

    if ($stdout)
        echo $stdout;
    else
        echo $stderr;
}
?>
