# vsuvky (částice i složitější potvůrky)
from rules import Rules


# parenteze?
interpositions = Rules('''
    (INTER coord_type) → (COORD coord_type)
    (INTER) → (OPT_COMMA) (PARTICLE) (OPT_COMMA)
    (INTER) → (OPT_COMMA) (DEP_CLAUSE) (OPT_COMMA)
    (INTER) → (OPT_COMMA) (NP c=5) (OPT_COMMA)  # oslovení/vokativ
    # '(INTER) → (OPT_COMMA) (NP c=[^5]) (OPT_COMMA)  # O.D.S.
    # '(INTER) → (COMMA) (CLAUSE) (COMMA)
    (INTER) → ε

    # odporovací částice (pak je odporovací i vztah mezi větama)
    (COORD coord_type=adversative) → (lemma=ale)

    # nevěřím desambiguátoru
    (PARTICLE) → (lemma="kéž|ať|nechť|ano|ne|jo|prý|nikoliv?|alespoň|'''
    'zejména|spíše?|snad|zajisté|nejspíše?|bohužel|ani|právě|však|možná|ovšem|'
    'proto|tedy|vůbec|až|ještě|také|taky|prosím")\n'
    # TODO: chtělo by to příklady :-)
)

# .insert_into_all('(word="(")', before=True)

# začíná/obsahuje:
# například, pokud, jak (již bylo řečeno)

rules = interpositions
